
function get_nest(fp_in, fp_out, line )
	local next_nest = 0
	local nest = 0
    if line~=nill then
        local c_nest = string.match (line, "^(%.+)")
		if c_nest ~= nil then
			nest = string.len(c_nest)
			if c_nest ~= nil and nest>0 then
				fp_out:write("<InformationElement isOpen=\"true\" informationFormat=\"ASCII\" expiryDate=\"Thursday 9 2 2014\" iconFileName=\"none\" isEncrypted=\"false\" expires=\"false\">\n")
				fp_out:write("<Description>"..string.sub(line,nest+1).."</Description>\n")
				fp_out:write("<Information><![CDATA[")
				local child_tag = false
				local same_tag = false
				local parent_tag = false
				line = fp_in:read()
				while line~=nil do
					nlen = string.len(line)
					c_nest = string.match (line, "^(%.+)")
					if c_nest~=nil then
						next_nest = string.len(c_nest)
						if next_nest>nest then
							child_tag = true
						elseif next_nest==nest then
							same_tag = true
						else
							parent_tag = true
						end
						break
					else
						fp_out:write(line.."\n")
					end
					line = fp_in:read()
				end
				fp_out:write("]]></Information>\n")
				
				if child_tag then
					child_tag = false
					next_nest,line = get_nest(fp_in, fp_out,line)
					if next_nest==nest  then
						same_tag = true
					end
				else
					-- next_nest = 0
				end
				fp_out:write("</InformationElement>\n")
				while same_tag do
					next_nest,line = get_nest(fp_in, fp_out,line)
					same_tag = (next_nest==nest)
				end
			end
        end
    end
	return next_nest, line
end

--[[
wz2tux.lua 
  this script will convert from wz editor format to tuxcards format.
  if you have use fitzNOTE, you can use this script after output by wz format. 
]]--

-- || Parameters || --
in_filename  = "input_utf8.txt"   -- input file name. This file should be utf8 format.
out_filename = "output_utf8.txt"  -- output file name. This file will be utf8 format.
root_title   = "TuxCrads"         -- root name of items tree. You can change root title.
-- || Parameters || --


-- @main script start
--   file open
fp_in  = io.open(in_filename,"r")
fp_out = io.open(out_filename,"w")

--   utf-8 bom ? then skip
local BOM = '\239\187\191'
local line = fp_in:read()
if string.len(line) >=3 then
	chk_bom = string.sub(line,1,3);
	if BOM==chk_bom then
		line = string.sub(line,4)
	end
end
--   -- print(line) -- debug 

fp_out:write("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n")
fp_out:write("<!DOCTYPE tuxcards_data_file>\n")
fp_out:write("<InformationCollection>\n")
fp_out:write("<LastActiveElement></LastActiveElement>\n")
fp_out:write("<InformationElement isOpen=\"true\" informationFormat=\"ASCII\" expiryDate=\"火 9 2 2014\" iconFileName=\"none\" isEncrypted=\"false\" expires=\"false\">\n")
fp_out:write("<Description>"..root_title.."</Description>\n")
fp_out:write("<Information><![CDATA[")
fp_out:write("]]></Information>\n")

get_nest(fp_in, fp_out, line )

fp_out:write("</InformationElement>\n")
fp_out:write("</InformationCollection>\n")

--   file close
fp_in:close()
fp_out:close()
-- @main script end
